Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue.cpp	(revision 123)
@@ -37,9 +37,9 @@
     usage_environment(_usage);
 
-#if DEBUG_Core_Glue == true
-    log_printf(INFO,Core_Glue,FUNCTION,_("<%s> Parameters"),_name.c_str());
-
-    std::cout << *param << std::endl;
-#endif    
+// #if DEBUG_Core_Glue == true
+//     log_printf(INFO,Core_Glue,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Core_Glue,FUNCTION,_("<%s> : Allocation"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_branch_complete.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_branch_complete.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_branch_complete.cpp	(revision 123)
@@ -33,4 +33,6 @@
         BRANCH_COMPLETE_OOO_ENGINE_ACK [i][j] = 0;
 
+    if (PORT_READ(in_NRESET))
+      {
     for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
       for (uint32_t j=0; j<_param->_ooo_engine_nb_inst_branch_complete[i]; ++j)
@@ -54,4 +56,5 @@
           PORT_WRITE(out_BRANCH_COMPLETE_OOO_ENGINE_MISS_PREDICTION [i][j], PORT_READ(in_BRANCH_COMPLETE_FRONT_END_MISS_PREDICTION [num_front_end][j]));
         }
+      }
 
     for (uint32_t i=0; i<_param->_nb_front_end; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_commit_event.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_commit_event.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_commit_event.cpp	(revision 123)
@@ -32,4 +32,6 @@
       COMMIT_EVENT_OOO_ENGINE_ACK [i] = 0;
 
+    if (PORT_READ(in_NRESET))
+      {
      for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
        {
@@ -57,4 +59,6 @@
        }
 
+      }
+
     for (uint32_t i=0; i<_param->_nb_front_end; ++i)
       PORT_WRITE(out_COMMIT_EVENT_FRONT_END_VAL [i], COMMIT_EVENT_FRONT_END_VAL [i]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_execute.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_execute.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_execute.cpp	(revision 123)
@@ -34,4 +34,6 @@
         EXECUTE_EXECUTE_LOOP_ACK [i][j] = 0;
     
+    if (PORT_READ(in_NRESET))
+      {
 
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
@@ -60,4 +62,5 @@
           PORT_WRITE(out_EXECUTE_OOO_ENGINE_DATA         [num_ooo_engine][num_execute_loop][j], PORT_READ(in_EXECUTE_EXECUTE_LOOP_DATA         [i][j]));
         }
+      }
 
     for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_insert.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_insert.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_insert.cpp	(revision 123)
@@ -22,4 +22,6 @@
     log_function(Core_Glue,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
       for (uint32_t j=0; j<_param->_execute_loop_nb_ooo_engine[i]; ++j)
@@ -50,4 +52,19 @@
             }
         }
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+          for (uint32_t j=0; j<_param->_execute_loop_nb_ooo_engine[i]; ++j)
+            {
+              Tcontext_t num_ooo_engine   = _param->_translate_execute_loop_num_ooo_engine [i][j];
+              
+              for (uint32_t k=0; k<_param->_execute_loop_nb_inst_insert[i][j]; ++k)
+                {
+                  PORT_WRITE(out_INSERT_OOO_ENGINE_ACK  [num_ooo_engine][k],0);
+                 PORT_WRITE(out_INSERT_EXECUTE_LOOP_VAL [i][j][k],0);
+                }
+            }
+      }
 
     log_end(Core_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Core_Glue/src/Core_Glue_genMealy_issue.cpp	(revision 123)
@@ -64,4 +64,14 @@
     Tcontrol_t ISSUE_OOO_ENGINE_ACK   [_param->_nb_ooo_engine  ][_param->_max_nb_inst_issue_queue];
     Tcontrol_t ISSUE_EXECUTE_LOOP_VAL [_param->_nb_execute_loop][_param->_max_nb_read_unit];
+
+    for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
+      for (uint32_t j=0; j<_param->_nb_inst_issue_queue[i]; ++j)
+        ISSUE_OOO_ENGINE_ACK [i][j] = 0;
+    for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+      for (uint32_t j=0; j<_param->_nb_read_unit[i]; ++j)
+        ISSUE_EXECUTE_LOOP_VAL [i][j] = 0;
+    
+    if (PORT_READ(in_NRESET))
+      {
     Tcontrol_t READ_UNIT_ENABLE       [_param->_nb_execute_loop][_param->_max_nb_read_unit];
     Tcontrol_t SLOT_ENABLE            [_param->_nb_ooo_engine  ][_param->_max_nb_inst_issue_slot];
@@ -69,16 +79,10 @@
     // Init -> all at 0
     for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
-      {
-        for (uint32_t j=0; j<_param->_nb_inst_issue_queue[i]; ++j)
-          ISSUE_OOO_ENGINE_ACK [i][j] = 0;
-        for (uint32_t j=0; j<_param->_nb_inst_issue_slot[i]; ++j)
-          SLOT_ENABLE [i][j] = 1;         
-      }
+      for (uint32_t j=0; j<_param->_nb_inst_issue_slot[i]; ++j)
+        SLOT_ENABLE [i][j] = 1;         
 
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
       for (uint32_t j=0; j<_param->_nb_read_unit[i]; ++j)
         {
-          ISSUE_EXECUTE_LOOP_VAL [i][j] = 0;
-
           // Read unit is enable is signal ack is set
           READ_UNIT_ENABLE       [i][j] = (PORT_READ(in_ISSUE_EXECUTE_LOOP_ACK [i][j]) == 1);
@@ -236,4 +240,6 @@
       }
 
+      }
+
     // Write output
     for (uint32_t i=0; i<_param->_nb_ooo_engine; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access.cpp	(revision 123)
@@ -37,9 +37,9 @@
     usage_environment(_usage);
 
-#if DEBUG_Dcache_Access == true
-    log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Dcache_Access == true
+//     log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Dcache_Access,FUNCTION,_("<%s> : Allocation"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_req.cpp	(revision 123)
@@ -21,4 +21,6 @@
     log_begin(Dcache_Access,FUNCTION);
 
+    if (PORT_READ(in_NRESET))
+      {
     Tcontrol_t dcache_req_val [_param->_nb_dcache_port];
     for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
@@ -105,4 +107,16 @@
 	for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
 	  PORT_WRITE(out_LSQ_REQ_ACK [i][j][k], lsq_req_ack [i][j][k]);
+      }
+
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+          PORT_WRITE(out_DCACHE_REQ_VAL [i], 0);
+        
+        for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+          for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+            for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+              PORT_WRITE(out_LSQ_REQ_ACK [i][j][k], 0);
+      }
 
     log_end(Dcache_Access,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_rsp.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_rsp.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Dcache_Access/src/Dcache_Access_genMealy_rsp.cpp	(revision 123)
@@ -21,4 +21,6 @@
     log_begin(Dcache_Access,FUNCTION);
 
+    if (PORT_READ(in_NRESET))
+      {
     Tcontrol_t lsq_rsp_val [_param->_nb_execute_loop][_param->_max_nb_load_store_unit][_param->_max_nb_cache_access];
     for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
@@ -87,4 +89,15 @@
 	for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
 	  PORT_WRITE(out_LSQ_RSP_VAL [i][j][k], lsq_rsp_val [i][j][k]);
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_dcache_port; ++i)
+          PORT_WRITE(out_DCACHE_RSP_ACK [i],0);
+
+        for (uint32_t i=0; i<_param->_nb_execute_loop; ++i)
+          for (uint32_t j=0; j<_param->_nb_load_store_unit[i]; ++j)
+            for (uint32_t k=0; k<_param->_nb_cache_access [i][j]; ++k)
+              PORT_WRITE(out_LSQ_RSP_VAL [i][j][k], 0);
+      }
 
     log_end(Dcache_Access,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access.cpp	(revision 123)
@@ -37,9 +37,9 @@
     usage_environment(_usage);
 
-#if DEBUG_Core == true
-    log_printf(INFO,Core,FUNCTION,_("<%s> Parameters"),_name.c_str());
-
-    std::cout << *param << std::endl;
-#endif    
+// #if DEBUG_Core == true
+//     log_printf(INFO,Core,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Icache_Access,FUNCTION,_("<%s> : Allocation"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_req.cpp	(revision 123)
@@ -23,7 +23,14 @@
     Tcontrol_t icache_req_val [_param->_nb_icache_port];
     for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+      icache_req_val [i] = 0;
+    Tcontrol_t context_req_ack [_param->_nb_front_end][_param->_max_nb_context];
+    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
+      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
+	context_req_ack [i][j] = 0;
+
+    if (PORT_READ(in_NRESET))
       {
-	icache_req_val [i] = 0;
-
+    for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+      {
 #ifdef STATISTICS
 	_internal_ICACHE_REQ_NB_ACCESS         [i] = 0;
@@ -32,9 +39,4 @@
       }
     
-    Tcontrol_t context_req_ack [_param->_nb_front_end][_param->_max_nb_context];
-    for (uint32_t i=0; i<_param->_nb_front_end; ++i)
-      for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
-	context_req_ack [i][j] = 0;
-	
     std::list<generic::priority::select_t> * select = _priority ->select();
     for (std::list<generic::priority::select_t>::iterator it=select ->begin();
@@ -85,4 +87,6 @@
 	  }
       }
+      }
+
 
     for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Icache_Access/src/Icache_Access_genMealy_rsp.cpp	(revision 123)
@@ -26,4 +26,6 @@
 	context_rsp_val [i][j] = 0;
 
+    if (PORT_READ(in_NRESET))
+      {
     for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
       {
@@ -75,4 +77,9 @@
       }
 
+      }
+    else
+      for (uint32_t i=0; i<_param->_nb_icache_port; ++i)
+	PORT_WRITE(out_ICACHE_RSP_ACK [i],0);
+
     for (uint32_t i=0; i<_param->_nb_front_end; ++i)
       for (uint32_t j=0; j<_param->_nb_context[i]; ++j)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue.cpp	(revision 123)
@@ -39,9 +39,9 @@
     usage_environment(_usage);
 
-#if DEBUG_Execute_loop_Glue == true
-    log_printf(INFO,Execute_loop_Glue,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Execute_loop_Glue == true
+//     log_printf(INFO,Execute_loop_Glue,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Execute_loop_Glue,FUNCTION,_("<%s> : Allocation"),_name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue_genMealy_gpr_write.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue_genMealy_gpr_write.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue_genMealy_gpr_write.cpp	(revision 123)
@@ -23,4 +23,6 @@
     log_begin(Execute_loop_Glue,FUNCTION);
 
+    if (PORT_READ(in_NRESET))
+      {
     for (uint32_t i=0; i<_param->_nb_gpr_write; i++)
       {
@@ -45,4 +47,14 @@
 	PORT_WRITE(out_GPR_WRITE_READ_UNIT_DATA               [i],data         );
       }
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_gpr_write; i++)
+          {
+            PORT_WRITE(out_GPR_WRITE_WRITE_UNIT_ACK               [i],0);
+            PORT_WRITE(out_GPR_WRITE_REGISTER_FILE_VAL            [i],0);
+            PORT_WRITE(out_GPR_WRITE_READ_UNIT_VAL                [i],0);
+          }
+      }
 
     log_end(Execute_loop_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue_genMealy_spr_write.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue_genMealy_spr_write.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Execute_loop_Glue/src/Execute_loop_Glue_genMealy_spr_write.cpp	(revision 123)
@@ -23,4 +23,6 @@
     log_begin(Execute_loop_Glue,FUNCTION);
 
+    if (PORT_READ(in_NRESET))
+      {
     for (uint32_t i=0; i<_param->_nb_spr_write; i++)
       {
@@ -45,4 +47,14 @@
 	PORT_WRITE(out_SPR_WRITE_READ_UNIT_DATA               [i],data         );
       }
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_spr_write; i++)
+          {
+            PORT_WRITE(out_SPR_WRITE_WRITE_UNIT_ACK               [i],0);
+            PORT_WRITE(out_SPR_WRITE_REGISTER_FILE_VAL            [i],0);
+            PORT_WRITE(out_SPR_WRITE_READ_UNIT_VAL                [i],0);
+          }
+      }
 
     log_end(Execute_loop_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit.cpp	(revision 123)
@@ -42,9 +42,9 @@
     allocation ();
 
-#if DEBUG_Functionnal_unit == true
-    log_printf(INFO,Functionnal_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Functionnal_unit == true
+//     log_printf(INFO,Functionnal_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
 #ifdef STATISTICS
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMealy.cpp	(revision 123)
@@ -31,6 +31,4 @@
           // Can out if : have an instruction and is finish (latence == 0)
           internal_EXECUTE_OUT_VAL = (reg_BUSY_OUT and (_execute_operation_out->_timing._latence == 0));
-          
-          PORT_WRITE(out_EXECUTE_OUT_VAL, internal_EXECUTE_OUT_VAL);
         }
         
@@ -50,8 +48,16 @@
                                      (internal_EXECUTE_OUT_VAL and PORT_READ(in_EXECUTE_OUT_ACK)));
             }
-
-          PORT_WRITE(out_EXECUTE_IN_ACK , internal_EXECUTE_IN_ACK);
         }
       }
+    else
+      {
+        // RESET
+        internal_EXECUTE_IN_ACK = 0;
+        internal_EXECUTE_OUT_VAL = 0;
+      }
+
+    // Write Output
+    PORT_WRITE(out_EXECUTE_IN_ACK , internal_EXECUTE_IN_ACK);
+    PORT_WRITE(out_EXECUTE_OUT_VAL, internal_EXECUTE_OUT_VAL);
 
     log_end(Functionnal_unit,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMoore.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/src/Functionnal_unit_genMoore.cpp	(revision 123)
@@ -26,4 +26,5 @@
     log_function(Functionnal_unit,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
     {
       if (_param->_have_port_context_id)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit.cpp	(revision 123)
@@ -39,9 +39,9 @@
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
 
-#if DEBUG_Load_store_unit == true
-    log_printf(INFO,Load_store_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
-
-    std::cout << *param << std::endl;
-#endif    
+// #if DEBUG_Load_store_unit == true
+//     log_printf(INFO,Load_store_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+//     std::cout << *param << std::endl;
+// #endif    
 
 #ifdef SYSTEMC
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMealy_insert.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMealy_insert.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMealy_insert.cpp	(revision 123)
@@ -35,4 +35,6 @@
       ack [i] = 0;
 
+    if (PORT_READ(in_NRESET))
+      {
     // find first valid entry
     // store queue is never full (pointer is manage by rename stage)
@@ -49,4 +51,10 @@
 	    }
 	}
+      }
+    else
+      {
+        internal_MEMORY_IN_ACK = 0;
+//         internal_MEMORY_IN_PORT = i;
+      }
 
     for (uint32_t i=0; i<_param->_nb_inst_memory; i++)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_function_speculative_load_commit_genMoore.cpp	(revision 123)
@@ -27,4 +27,6 @@
     log_function(Load_store_unit,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     // ~~~~~[ Interface "memory_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
@@ -140,6 +142,4 @@
 
     // write output
-    PORT_WRITE(out_MEMORY_OUT_VAL          [0], internal_MEMORY_OUT_VAL);
-
     if (_param->_have_port_context_id)
     PORT_WRITE(out_MEMORY_OUT_CONTEXT_ID   [0], memory_out_context_id   );
@@ -171,9 +171,9 @@
     // ~~~~~[ Interface "dache_req" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
-    Tcontext_t        dcache_req_context_id;
-    Tpacket_t         dcache_req_packet_id ;
-    Tdcache_address_t dcache_req_address   ;
-    Tdcache_type_t    dcache_req_type      ;
-    Tdcache_data_t    dcache_req_wdata     ;
+    Tcontext_t        dcache_req_context_id = 0;
+    Tpacket_t         dcache_req_packet_id  = 0;
+    Tdcache_address_t dcache_req_address    = 0;
+    Tdcache_type_t    dcache_req_type       = 0;
+    Tdcache_data_t    dcache_req_wdata      = 0;
 
     log_printf(TRACE,Load_store_unit,FUNCTION,"  * Test DCACHE_REQ");
@@ -241,5 +241,4 @@
       }
 
-    PORT_WRITE(out_DCACHE_REQ_VAL       [0], internal_DCACHE_REQ_VAL);
     if (_param->_have_port_dcache_context_id)
     PORT_WRITE(out_DCACHE_REQ_CONTEXT_ID[0], dcache_req_context_id);
@@ -248,5 +247,22 @@
     PORT_WRITE(out_DCACHE_REQ_TYPE      [0], dcache_req_type      );
     PORT_WRITE(out_DCACHE_REQ_WDATA     [0], dcache_req_wdata     );
-    
+      }
+    else
+      {
+        // Reset
+    internal_MEMORY_OUT_VAL = 0;
+//  internal_MEMORY_OUT_PTR =0
+//  internal_MEMORY_OUT_SELECT_QUEUE = SELECT_STORE_QUEUE;
+
+    internal_DCACHE_REQ_VAL = 0;
+    internal_SPECULATIVE_ACCESS_QUEUE_PTR_READ = 0;
+//  internal_DCACHE_REQ_SELECT_QUEUE = SELECT_LOAD_QUEUE_SPECULATIVE;
+      }
+
+    // Write output
+    PORT_WRITE(out_MEMORY_OUT_VAL [0], internal_MEMORY_OUT_VAL);
+    PORT_WRITE(out_DCACHE_REQ_VAL [0], internal_DCACHE_REQ_VAL);
+
+
     log_end(Load_store_unit,FUNCTION);
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_genMoore.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Load_store_unit/src/Load_store_unit_genMoore.cpp	(revision 123)
@@ -26,4 +26,5 @@
     log_printf(FUNC,Load_store_unit,FUNCTION,"Begin");
 
+//     if (PORT_READ(in_NRESET))
     (this->*function_genMoore) ();
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue.cpp	(revision 123)
@@ -36,9 +36,9 @@
     log_printf(FUNC,Read_queue,"Read_queue","Begin");
 
-#if DEBUG_Read_queue == true
-    log_printf(INFO,Read_queue,FUNCTION,_("<%s> Parameters"),_name.c_str());
-
-    std::cout << *param << std::endl;
-#endif    
+// #if DEBUG_Read_queue == true
+//     log_printf(INFO,Read_queue,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+//     std::cout << *param << std::endl;
+// #endif    
 
 #ifdef SYSTEMC
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_gpr.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_gpr.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_gpr.cpp	(revision 123)
@@ -25,4 +25,6 @@
     log_function(Read_queue,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     internal_READ_QUEUE_OUT_DATA_RA_VAL = (// Previous value
 					   _queue_head->_data_ra_val or
@@ -102,8 +104,17 @@
 
     // Affectation out port
+    PORT_WRITE(out_READ_QUEUE_OUT_DATA_RA    ,internal_READ_QUEUE_OUT_DATA_RA    );
+    PORT_WRITE(out_READ_QUEUE_OUT_DATA_RB    ,internal_READ_QUEUE_OUT_DATA_RB    );
+      }
+    else
+      {
+        internal_READ_QUEUE_OUT_DATA_RA_VAL = 0;
+        internal_READ_QUEUE_OUT_DATA_RB_VAL = 0;
+//         internal_READ_QUEUE_OUT_DATA_RA = 0;
+//         internal_READ_QUEUE_OUT_DATA_RB = 0;
+      }
+
     PORT_WRITE(out_READ_QUEUE_OUT_DATA_RA_VAL,internal_READ_QUEUE_OUT_DATA_RA_VAL);
     PORT_WRITE(out_READ_QUEUE_OUT_DATA_RB_VAL,internal_READ_QUEUE_OUT_DATA_RB_VAL);
-    PORT_WRITE(out_READ_QUEUE_OUT_DATA_RA    ,internal_READ_QUEUE_OUT_DATA_RA    );
-    PORT_WRITE(out_READ_QUEUE_OUT_DATA_RB    ,internal_READ_QUEUE_OUT_DATA_RB    );
 
     log_end(Read_queue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_spr.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_spr.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_spr.cpp	(revision 123)
@@ -25,4 +25,6 @@
     log_function(Read_queue,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     internal_READ_QUEUE_OUT_DATA_RC_VAL = (// Previous value
 					   _queue_head->_data_rc_val or
@@ -72,6 +74,13 @@
 
     // Affectation out port
+    PORT_WRITE(out_READ_QUEUE_OUT_DATA_RC    ,internal_READ_QUEUE_OUT_DATA_RC    );
+      }
+    else
+      {
+        internal_READ_QUEUE_OUT_DATA_RC_VAL = 0;
+//         internal_READ_QUEUE_OUT_DATA_RC
+      }
+
     PORT_WRITE(out_READ_QUEUE_OUT_DATA_RC_VAL,internal_READ_QUEUE_OUT_DATA_RC_VAL);
-    PORT_WRITE(out_READ_QUEUE_OUT_DATA_RC    ,internal_READ_QUEUE_OUT_DATA_RC    );
 
     log_end(Read_queue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_val.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_val.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_genMealy_read_queue_out_val.cpp	(revision 123)
@@ -25,4 +25,6 @@
     log_function(Read_queue,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     internal_READ_QUEUE_OUT_READ_RA_VAL = (// Previous value
 					   _queue_head->_read_ra_val  and
@@ -98,6 +100,4 @@
 
 
-    PORT_WRITE(out_READ_QUEUE_OUT_VAL, internal_READ_QUEUE_OUT_VAL);
-
     log_printf(TRACE,Read_queue,FUNCTION,"  * internal_READ_QUEUE_OUT_VAL           : %d",internal_READ_QUEUE_OUT_VAL);
     log_printf(TRACE,Read_queue,FUNCTION,"    * _queue->empty()                     : %d",_queue->empty());
@@ -111,4 +111,11 @@
     log_printf(TRACE,Read_queue,FUNCTION,"      * _queue_head->_read_rc_val         : %d",_queue_head->_read_rc_val);
     log_printf(TRACE,Read_queue,FUNCTION,"      * in_SPR_READ_ACK      [0]          : %d",PORT_READ(in_SPR_READ_ACK      [0]));
+      }
+    else
+      {
+        internal_READ_QUEUE_OUT_VAL = 0;
+      }
+
+    PORT_WRITE(out_READ_QUEUE_OUT_VAL, internal_READ_QUEUE_OUT_VAL);
 
     log_end(Read_queue,FUNCTION);
